/* Copyright Microsoft Corporation. All rights reserved. */

#include "c.h"
/* #include <time.h> */

#define I(f) opt_##f
static char rcsid[] = "$Id: opt.c,v 1.1 2004/10/05 07:21:37 andbe Exp $";

/* static const char *uname;	/\* unique name prefix *\/ */
/* static int maxstack;		/\* maximum amount of stack space used, in bytes *\/ */
/* static int maxlocals;		/\* maximum amount of local space used, in bytes *\/ */
/* static Table ILtypes;		/\* generated MSIL types *\/ */

//typedef short *Indeg;            /* Indegrees */
extern Node cg_gen(Node); //, Indeg);
extern void cg_emit(Node, char *); //Indeg, char *);
extern void cg_function(Symbol, Symbol*, Symbol*, int);
extern void cg_initialize(int, char **);
extern void cg_finalize(void);

//static Indeg indeg;

static void I(segment)(int n) { print(":segment\n"); }
static void I(blockbeg)(Env *e) { print(":blockbeg\n"); }
static void I(blockend)(Env *e) { print(":blockend\n"); }

/* address - initialize q for addressing expression p+n */
static void I(address)(Symbol q, Symbol p, long n) { print(":address\n"); }
/* 	q->name = p->name; */
/* 	q->x.name = p->x.name; */
/* 	q->x.offset = n; */
/* 	q->type = p->type; */
/* } */

//#define print printstr
static void I(defaddress)(Symbol p) { print(":defaddress\n"); }

/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	if (!isfunc(p->type) && (!p->computed || p->x.offset == 0)) */
/* 		print("&(%s)", datalabel(p)); */
/* 	else { */
/* 		initbuffer = appendstr(initbuffer, */
/* 			"ldsflda %s %s\n" */
/* 			"ldc.i4 %d\n" */
/* 			"add\n", gettype(current->type), current->x.name, lc); */
/* 		if (isfunc(p->type)) */
/* 			initbuffer = appendstr(initbuffer, */
/* 				"ldftn %s\n" */
/* 				"stind.i4\n", signature(p->type, p->x.name)); */
/* 		else */
/* 			initbuffer = appendstr(initbuffer, */
/* 				"ldsflda %s %s\n" */
/* 				"ldc.i4 %d\n" */
/* 				"add\n" */
/* 				"stind.i4\n", gettype(p->type), p->x.name, p->x.offset); */
/* 		print("int%d (0)", 8*voidptype->size); */
/* 	} */
/* 	lc += voidptype->size; */
/* } */


static void I(defconst)(int suffix, int size, Value v) { print(":defconst\n"); }
/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	switch (suffix) { */
/* 	case I: print("int%d (%d)", 8*size, v.i); break; */
/* 	case U: print("int%d (%u)", 8*size, (long)v.u); break; */
/* 	case P: print("int%d (%p)", 8*size, v.p); break; */
/* 	case F: print("float%d (%s)", 8*size, tostring(v.d)); break; */
/* 	default: assert(0); */
/* 	} */
/* 	lc += size; */
/* } */

static void I(defstring)(int len, char *str) { print(":defstring\n"); }
/* 	int i; */

/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	print("bytearray ("); */
/* 	for (i = 0; i < len; i++) { */
/* 		if (i > 0 && i%30 == 0) */
/* 			print("\n"); */
/* 		print(" %x", (unsigned char)str[i]); */
/* 	} */
/* 	print(" )"); */
/* 	lc += len; */
/* } */
/* #undef print */

static void I(space)(int n) { print(":space\n"); }
/* 	static Value v = { 0 }; */

/* 	for ( ; n >= 4; n -= 4) */
/* 		(*IR->defconst)(I, 4, v); */
/* 	for ( ; n >= 2; n -= 2) */
/* 		(*IR->defconst)(I, 2, v); */
/* 	for ( ; n >  0; n -= 1) */
/* 		(*IR->defconst)(I, 1, v); */
/* } */

static void I(defsymbol)(Symbol p) { print(":symbol\n"); }
/* 	if (p->sclass == STATIC && p->generated) */
/* 		p->x.name = stringf("$%s_%s", uname, p->name); */
/* 	else if (p->sclass == STATIC) */
/* 		p->x.name = stringf("$%s%d_%s", uname, genlabel(1), p->name); */
/* 	else if (p->scope == LABELS) */
/* 		p->x.name = stringf("$L%s", p->name); */
/* 	else if (p->generated) */
/* 		p->x.name = stringf("$%s", p->name); */
/* 	else */
/* 		p->x.name = stringf("'%s'", p->name); */
/* } */

static void I(global)(Symbol p) { print(":global\n"); }
/* 	closedata(); */
/* 	gettypename(p->type); */
/* 	print(".field public static %s %s at %s\n", gettype(p->type), p->x.name, datalabel(p)); */
/* 	current = p; */
/* } */

static void I(emit)(Node p) {
  cg_emit(p, "archi.xml"); //indeg, "archi.xml");
}

static void I(local)(Symbol p) { print(":local\n"); }
/* 	p->x.offset = maxlocals/4; */
/* 	maxlocals = roundup(maxlocals + p->type->align, 4); */
/* 	locals = append(p, locals); */
/* 	if (isarray(p->type) && p->type->type->size > 0) */
/* 		emittype(stringf("%s[%d]", gettypename(p->type->type), */
/* 			p->type->size/p->type->type->size), p->type); */
/* 	else */
/* 		gettypename(p->type); */
/* } */

static void I(export)(Symbol p) { print(":export\n"); }

/* static int reg, argcount, argno; */

static void I(function)(Symbol f, Symbol caller[], Symbol callee[], int ncalls) {
  cg_function(f, caller, callee, ncalls);
  print(":function\n");
/* 	int i; */

/* 	closedata(); */
/* 	maxstack = maxlocals = 0; */
/* 	for (i = 0; caller[i] && callee[i]; i++) { */
/* 		caller[i]->x.offset = i; */
/* 		callee[i]->sclass = caller[i]->sclass; */
/* 		callee[i]->x.offset = i; */
/* 	} */
/* 	reg = 0; */
	gencode(caller, callee);
/* 	print(".method public hidebysig static %s cil managed {\n", signature(f->type, f->x.name)); */
/* 	{ */
/* 		Symbol *argv = ltov(&locals, FUNC); */
/* 		for (i = 0; argv[i] != NULL; i++) { */
/* 			print(".locals ([%d] ", argv[i]->x.offset); */
/* 			if (isarray(argv[i]->type) && argv[i]->type->type->size > 0) */
/* 				print("valuetype '%s[%d]'", gettypename(argv[i]->type->type), */
/* 				      argv[i]->type->size/argv[i]->type->type->size); */
/* 			else */
/* 				print("%s", gettype(argv[i]->type)); */
/* 			print(" '%s')\n", argv[i]->name); */
/* 		} */
/* 	} */
/* 	assert(maxstack%4 == 0); */
/* 	maxstack = roundup(maxstack, voidptype->size); */
/* 	print(".maxstack %d\n", maxstack/voidptype->size); */
 	emitcode();
/* 	print("ret\n}\n"); */
}



static Node I(gen)(Node p) {
  return cg_gen(p); //, indeg);
/* 	head.x.next = head.x.prev = &head; */
/* 	argcount = 0; */
/* 	for ( ; p != NULL; p = p->link) { */
/* 		visit(p); */
/* 		if (generic(p->op) == CALL && p->op != CALL+V) { */
/* 			p->x.listed = 1; */
/* 			reg -= opsize(p->op); */
/* 		} */
/* 	} */
/* 	assert(argcount == 0); */
/* 	head.x.prev->x.next = NULL; */
/* 	for (p = head.x.next; p != NULL; p = p->x.next) */
/* 		switch (generic(p->op)) { */
/* 		case ADDRG: gettype(p->syms[0]->type); break; */
/* 		case INDIR: case ASGN: */
/* 			if (generic(p->kids[0]->op) == ADDRG) */
/* 				gettype(p->kids[0]->syms[0]->type); */
/* 			break; */
/* 		} */
/* 	return head.x.next; */
}

static void I(import)(Symbol p) { 
   print(":import\n");
/* 	closedata(); */
}

static void I(progbeg)(int argc, char *argv[]) {
  print(":progbeg\n");
  cg_initialize(argc, argv);
}

/* 	int i; */

/* 	density = 1.1; */
/* 	ILtypes = newtable(PERM); */
/* 	{ */
/* 		extern int getpid(void); */
/* 		time_t t, prev = time(NULL); */
/* 		while ((t = time(NULL)) == prev) */
/* 			; */
/* 		uname = stringf("%x_%x_", t, getpid()); */
/* 	} */
/* 	for (i = 0; i < argc; i++) */
/* 		if (strncmp(argv[i], "-uname=", 7) == 0) */
/* 			uname = argv[i] + 7; */
/* 	print("//"); */
/* 	if (firstfile != NULL) */
/* 		print(" file=%s", firstfile); */
/* 	print(" uname=%s\n", uname); */
/* } */

static void I(progend)(void) {
  print(":progend\n");
  cg_finalize();
}
/* 	closedata(); */
/* 	if (initbuffer != NULL) { */
/* 		print(".method public hidebysig static void $$%s_init() cil managed {\n" */
/* 		      ".maxstack 3\n", uname); */
/* 		printlist(&initbuffer); */
/* 		print("ret\n}\n"); */
/* 		print("//$$INIT call void $$%s_init()\n", uname); */
/* 	} */
/* } */

Interface optIR = {
	1, 1, 0,	/* char */
	2, 2, 0,	/* short */
	4, 4, 0,	/* int */
	4, 4, 0,	/* long */
	4, 4, 0,	/* long long */
	4, 4, 0,	/* float */
	8, 4, 0,	/* double */
	8, 4, 0,	/* long double */
	4, 4, 0,	/* T * */
	0, 1, 0,	/* struct; so that ARGB keeps stack aligned */
	1,		/* little_endian */
	0,		/* mulops_calls */
	0,		/* wants_callb */
	0,		/* wants_argb */
	1,		/* left_to_right */
	1,		/* wants_dag */
	0,		/* unsigned_char */
	0,		/* I(address) */
	I(blockbeg),
	I(blockend),
	I(defaddress),
	I(defconst),
	I(defstring),
	I(defsymbol),
	I(emit),
	I(export),
	I(function),
	I(gen),
	I(global),
	I(import),
	I(local),
	I(progbeg),
	I(progend),
	I(segment),
	I(space),
	0,		/* I(stabblock) */
	0,		/* I(stabend) */
	0,		/* I(stabfend) */
	0,		/* I(stabinit) */
	0,		/* I(stabline) */
	0,		/* I(stabsym) */
	0,		/* I(stabtype) */
};

#undef I
